<?xml version="1.0"?>
<cfsSimulation xmlns="http://www.cfs++.org/simulation"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xsi:schemaLocation="http://www.cfs++.org/simulation 
    file:/home/kroppert/Devel/CFS_SRC/latest_trunkGit/CFS/share/xml/CFS-Simulation/CFS.xsd">
    
    <documentation>
        <title>Energy based hysteresis 3d sphere </title>
        <authors>
            <author>kroppert</author>
        </authors>
        <date>2022-08-15</date>
        <keywords>
            <keyword>magneticScalar</keyword>
            <keyword>hysteresis</keyword>
        </keywords>
        <references></references>
        <isVerified>no</isVerified>
        <description> 3d example of magnetic scalar potential PDE in Psi formulation
                      with energy based hysteresis. The model consists of a sphere
                      and it is excited via 3d Dirichlet BC's (spherical harmonics).
                      The kind of linesearch which is used here is Armijo
         </description>
      </documentation>

    <!-- define which files are needed for simulation input & output-->
    <fileFormats>
        <input>
            <hdf5 fileName="EBVecHyst_3dsphere_Armijo.h5ref"/>
        </input>
        <output>
            <hdf5 id="hdf5"/>
            <text id="txt"/>
        </output>
        <materialData file="mat.xml" format="xml"/>
    </fileFormats>

    <domain geometryType="3d">
        <regionList>
            <region name="V_sphere" material="iron" />
        </regionList>
    </domain>


    <sequenceStep index="1">
        <analysis>
            <transient initialTime="zero">
                <numSteps>5</numSteps>
                <deltaT>0.2</deltaT>
            </transient>
        </analysis>

        <pdeList>
            <magnetic formulation="Psi">
                <regionList>
                    <region name="V_sphere" nonLinIds="nl1"/>
                </regionList>

                <nonLinList>
                    <permeability id="nl1" model="EBHysteresisModel" />
                </nonLinList>
            
                <bcsAndLoads>
                    <potential name="S_outer" value="-10*t*sqrt(1-(cos(acos(z/sqrt(x^2+y^2+z^2)))^2))*cos(atan2(y,x)+t)" />
                    <!-- <potential name="S_outer" value="10*t*cos(acos(z/sqrt(x^2+y^2+z^2))+t)" /> -->
                </bcsAndLoads>

                <storeResults>
                    <elemResult type="magFieldIntensity">
                        <allRegions/>
                    </elemResult>
                    <elemResult type="magFluxDensity">
                        <allRegions/>
                    </elemResult>
                    <nodeResult type="magPotential">
                        <allRegions/>
                    </nodeResult>
                </storeResults>
            </magnetic>
        </pdeList>

        <linearSystems>
            <system>
                <solutionStrategy>
                    <standard>
                          <nonLinear logging="yes" method="fixPoint" >
                                      <lineSearch type="Armijo"/>
                                      <incStopCrit> 1e-3</incStopCrit>
                                      <resStopCrit> 1e-3</resStopCrit>
                                      <maxNumIters>100</maxNumIters>
                                      <abortOnMaxNumIters>yes</abortOnMaxNumIters>
                          </nonLinear>
                      </standard>
                </solutionStrategy>
            </system>
        </linearSystems>
    </sequenceStep>

    <sequenceStep index="2">
        <analysis>
            <transient initialTime="zero">
                <numSteps>5</numSteps>
                <deltaT>0.2</deltaT>
            </transient>
        </analysis>

        <pdeList>
            <magnetic formulation="Psi">
                <regionList>
                    <region name="V_sphere" nonLinIds="nl1"/>
                </regionList>

                <nonLinList>
                    <permeability id="nl1" model="EBHysteresisModel" />
                </nonLinList>
            
                <bcsAndLoads>
                    <!-- <potential name="S_outer" value="-10*t*sqrt(1-(cos(acos(z/sqrt(x^2+y^2+z^2)))^2))*cos(atan2(y,x)+t)" /> -->
                    <potential name="S_outer" value="10*t*cos(acos(z/sqrt(x^2+y^2+z^2))+t)" />
                </bcsAndLoads>

                <storeResults>
                    <elemResult type="magFieldIntensity">
                        <allRegions/>
                    </elemResult>
                    <elemResult type="magFluxDensity">
                        <allRegions/>
                    </elemResult>
                    <nodeResult type="magPotential">
                        <allRegions/>
                    </nodeResult>
                </storeResults>
            </magnetic>
        </pdeList>

        <linearSystems>
            <system>
                <solutionStrategy>
                    <standard>
                          <nonLinear logging="yes" method="fixPoint" >
                                      <lineSearch type="Armijo"/>
                                      <incStopCrit> 1e-3</incStopCrit>
                                      <resStopCrit> 1e-3</resStopCrit>
                                      <maxNumIters>100</maxNumIters>
                                      <abortOnMaxNumIters>yes</abortOnMaxNumIters>
                          </nonLinear>
                      </standard>
                </solutionStrategy>
            </system>
        </linearSystems>
    </sequenceStep>
</cfsSimulation>
